//+------------------------------------------------------------------+
//|                                             Volatility.Pivot.mq4 |
//+------------------------------------------------------------------+
#property copyright "thanks to S.B.T. (Japan)"
#property link      "http://sufx.core.t3-ism.net/" //<<< convert this from VT, thanks mate !!!
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  clrSilver
#property indicator_color2  clrBlue
#property indicator_color3  clrBlue
#property indicator_color4  clrRed
#property indicator_color5  clrRed
#property strict

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_tbiased2,   // Trend biased (extreme) price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased,  // Heiken ashi trend biased price
   pr_hatbiased2  // Heiken ashi trend biased (extreme) price
};
enum colorOn
{
   clrOnSlope,     // Color change on slope change
   clrOnPrcCross,  // Color change on price cross
};


extern double          atr_range       = 100;           // Atr range
extern double          ima_range       = 10;            // Ma range
extern double          atr_factor      = 3;             // Atr factor
extern int             Mode            = 0;             // Mode
extern double          DeltaPrice      = 30;            // Delta Price
extern enPrices        priceForAlerts  = pr_close;      // Price to use
extern bool            alertsOn        = false;         // Turn alerts on?
extern bool            alertsOnCurrent = true;          // Alerts on current (stil opened) bar?
extern bool            alertsMessage   = true;          // Alerts should show popup message?
extern bool            alertsSound     = false;         // Alerts should play alert sound?
extern bool            alertsEmail     = false;         // Alerts should send email?
extern bool            alertsNotify    = false;         // Alerts should send push notification?
extern int             linesWidth      = 3;             // Lines Width
extern colorOn         ColorChangeOn   = clrOnSlope;    // Color change on : 

//
//
//
//
//

double TrStop[];
double volua[];
double volub[];
double volda[];
double voldb[];
double ATR[];
double state[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0, TrStop);   SetIndexStyle(0,EMPTY,EMPTY,linesWidth); SetIndexLabel(0,"range base");
      SetIndexBuffer(1, volua);    SetIndexStyle(1,EMPTY,EMPTY,linesWidth); SetIndexLabel(1,"range base");
      SetIndexBuffer(2, volub);    SetIndexStyle(2,EMPTY,EMPTY,linesWidth); SetIndexLabel(2,"range base");
      SetIndexBuffer(3, volda);    SetIndexStyle(3,EMPTY,EMPTY,linesWidth); SetIndexLabel(3,"range base");
      SetIndexBuffer(4, voldb);    SetIndexStyle(4,EMPTY,EMPTY,linesWidth); SetIndexLabel(4,"range base");
      SetIndexBuffer(5, ATR);
      SetIndexBuffer(6, state);
   
   IndicatorShortName("Risenberg volatility capture");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-2); 

   //
   //
   //
   //
   //
   
      if (state[limit] == 1) CleanPoint(limit,volua,volub);
      if (state[limit] ==-1) CleanPoint(limit,volda,voldb);
      for(i=limit; i>=0; i--) ATR[i] = iATR(NULL,0,(int)atr_range,i);
      for(i=limit; i>=0; i--)
      {
         double DeltaStop;
         double price = getPrice(priceForAlerts,Open,Close,High,Low,i);
         if (Mode == 0)
               DeltaStop = iMAOnArray(ATR,0,(int)ima_range,0,MODE_EMA,i) * atr_factor;
         else  DeltaStop = DeltaPrice*Point*MathPow(10,MathMod(Digits,2));

         while (true)
         {
            if (Close[i]  == TrStop[i+1]) { TrStop[i] = TrStop[i+1]; break; }
            if (Close[i+1] < TrStop[i+1] && Close[i]<TrStop[i+1]) { TrStop[i] = fmin(TrStop[i+1], Close[i] + DeltaStop); break; }
            if (Close[i+1] > TrStop[i+1] && Close[i]>TrStop[i+1]) { TrStop[i] = fmax(TrStop[i+1], Close[i] - DeltaStop); break; }         
            if (Close[i]   > TrStop[i+1]) 
                 TrStop[i] = Close[i] - DeltaStop; 
            else TrStop[i] = Close[i] + DeltaStop;
            break;
         }
         
         volua[i] = EMPTY_VALUE;
         volub[i] = EMPTY_VALUE;
         volda[i] = EMPTY_VALUE;
         voldb[i] = EMPTY_VALUE;
         if (i<Bars-1) 
         {
            switch (ColorChangeOn)
            {
               case clrOnSlope: 
                  state[i] = state[i+1];
                  if (TrStop[i]>TrStop[i+1]) state[i] =  1;
                  if (TrStop[i]<TrStop[i+1]) state[i] = -1;
               break;
               case clrOnPrcCross:
                  state[i] = state[i+1];
                  if (price>TrStop[i])       state[i] =  1;
                  if (price<TrStop[i])       state[i] = -1;
               break;
            }                                    
         }
         if (state[i]== 1) PlotPoint(i,volua,volub,TrStop);
         if (state[i]==-1) PlotPoint(i,volda,voldb,TrStop);
      }
      manageAlerts();
      return(0);
   } 
   
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

#define priceInstances 1
double workHa[][priceInstances*4];
double getPrice(int tprice, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (tprice>=pr_haclose)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars); instanceNo*=4;
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = fmax(high[i],fmax(haOpen,haClose));
         double haLow   = fmin(low[i] ,fmin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (tprice)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
            case pr_hatbiased2:
               if (haClose>haOpen)  return(haHigh);
               if (haClose<haOpen)  return(haLow);
                                    return(haClose);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (tprice)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
      case pr_tbiased2:   
               if (close[i]>open[i]) return(high[i]);
               if (close[i]<open[i]) return(low[i]);
                                     return(close[i]);        
   }
   return(0);
}      

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] = from[i];  second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (state[whichBar] != state[whichBar+1])
      {
         switch (ColorChangeOn)
         {
            case clrOnSlope:
               if (state[whichBar]== 1) doAlert(whichBar,"sloping  up");
               if (state[whichBar]==-1) doAlert(whichBar,"sloping down");
               break;
            case clrOnPrcCross:
               if (state[whichBar]== 1) doAlert(whichBar,"price crossing up");
               if (state[whichBar]==-1) doAlert(whichBar,"price crossing down");
               break;
         }    
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," volatility pivot ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" volatility pivot ",message);
          if (alertsNotify)  SendNotification(message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
